with Riferimento_Comune; use Riferimento_Comune;
with Una_Risorsa; use Una_Risorsa;
with Ada.Real_Time; use Ada.Real_Time;
with Ada.Text_IO;

package body Consumatori is

   task body Consumatore_T is
      use Ada.Text_IO;

      K : Integer;
      --  come per il tipo Produttore_T, una variabile apposita denota
      --  il tempo assoluto del prossimo risveglio del task (ricorda che
      --  Periodo e' uno dei 2 discriminanti del tipo di task e nota il diverso
      --  stile di ciclo di attivita'/risveglio)
      Risveglio : Time := Inizio;

   begin
      for J in 1 .. Iterazioni loop
         Magazzino.Preleva (K);
         Put_Line
           ("Consumatore " & Positive'Image (Id) & ": prelevato prodotto " &
            Integer'Image (K) & ".");
         --  aggiorniamo il valore di Risveglio all'istante della prossima
         --  attivazione desiderata
         Risveglio := Risveglio + Milliseconds (Periodo);
         delay until Risveglio;
      end loop;
      Put_Line
        ("Consumatore "
         & Positive'Image (Id)
         & ": finito: ora vado in vacanza ...");
   end Consumatore_T;

end Consumatori;
