with Riferimento_Comune; use Riferimento_Comune;
with Una_Risorsa; use Una_Risorsa;
with Ada.Real_Time; use Ada.Real_Time;
with Ada.Text_IO;

package body Produttori is

   Work_Item : Natural := 0; -- what about data races?

   task body Produttore_T is
      use Ada.Text_IO;

      --  variabile che denota il tempo assoluto del prossimo risveglio
      --  del task (Periodo e' uno dei 2 discriminanti del tipo di task)
      Risveglio : Time := Inizio + Milliseconds (Periodo);

   begin
      for J in 1 .. Iterazioni loop
         --  il produttore si auto-sospende fino al tempo assoluto richiesto
         delay until Risveglio;
         Work_Item := Work_Item + 1;
         Magazzino.Inserisci (Work_Item);
         Put_Line
           ("Produttore  " & Positive'Image (Id) & ": inserito prodotto  " &
            Work_Item'Img & ".");
         --  aggiorniamo il valore di risveglio
         Risveglio := Risveglio + Milliseconds (Periodo);
      end loop;
      Put_Line
        ("Produttore  "
         & Positive'Image (Id)
         & ": finito: ora vado in pensione ...");

   end Produttore_T;

end Produttori;
